package fr.smallcrew.rest.converter;

import org.springframework.beans.factory.InitializingBean;
import org.springframework.http.HttpInputMessage;
import org.springframework.http.HttpOutputMessage;
import org.springframework.http.converter.AbstractHttpMessageConverter;
import org.springframework.http.converter.HttpMessageNotReadableException;
import org.springframework.http.converter.HttpMessageNotWritableException;

import java.io.IOException;

public class ConverterDelegate extends AbstractHttpMessageConverter<Object> implements InitializingBean {
  private RestConverter internal;

  @Override
  protected boolean supports(Class<?> clazz) {
    return internal.supports(clazz);
  }

  @Override
  protected Object readInternal(Class<?> clazz, HttpInputMessage inputMessage) throws IOException, HttpMessageNotReadableException {
    return internal.readInternal(clazz, inputMessage);
  }

  @Override
  protected void writeInternal(Object o, HttpOutputMessage outputMessage) throws IOException, HttpMessageNotWritableException {
    internal.writeInternal(o, outputMessage);
  }

  public void setInternal(RestConverter internal) {
    this.internal = internal;
  }

  @Override
  public void afterPropertiesSet() throws Exception {
    setSupportedMediaTypes(internal.getSupportedMediaTypes());
  }
}
